-- Function: spsale_new(character varying, character varying)

-- DROP FUNCTION spsale_new(character varying, character varying);

CREATE OR REPLACE FUNCTION spsale_new(_saleno character varying, _billno character varying)
  RETURNS SETOF spstatus AS
$BODY$
DECLARE
	_retval			SPStatus%ROWTYPE;
	_spret			SPStatus%ROWTYPE;

	_CustID			VARCHAR(15);
	_CustID2		VARCHAR(15);
	_SaleType		VARCHAR(3);
	_SaleDate		DATE;
	_SONo			VARCHAR(15);
	_TermType		VARCHAR(1);
	_Term			INT;
	_PoSID			VARCHAR(5);
	_PoSSesNo		VARCHAR(8);

	_isTaxed		BOOLEAN;
	_isTaxInc		BOOLEAN;

	_SubTotal		DECIMAL(19,4);
	_Total			DECIMAL(19,4);
	_MDiscAmt		NUMERIC(19,4);
	_PaidAmt		DECIMAL(19,4);
	_CrtBy			VARCHAR(10);
	_CrtDate		TIMESTAMP;
	_UpdBy			VARCHAR(10);
	_UpdDate		TIMESTAMP;
	_DeliNo			VARCHAR(15);
	_SaleDNo		INT;
	_SaleNo2		VARCHAR(15);

	_StockAType		VARCHAR(5):='SALE';
	_isInsert		BOOLEAN:=true;

	_StockANo		VARCHAR(15);
	_StockANote		VARCHAR(255);
	_StockADNo		SMALLINT;
	_ItemID			VARCHAR(20);
	_WhID			VARCHAR(3);
	_PID			VARCHAR(25);
	_Qty			DECIMAL(15,4);
	_Unit			VARCHAR(5);
	_Conv			DECIMAL(15,4);
	_QtyX			DECIMAL(15,4);
	_BasePrice		DECIMAL(19,4);
	_ListPrice 		DECIMAL(19,4);
	_DiscExp		VARCHAR(15);
	_DiscAmt		DECIMAL(19,4);
	_TaxID			VARCHAR(5);
	_TaxAmt			DECIMAL(19,4);
	_MTaxAmt		DECIMAL(19,4);
	_MSCAmt			DECIMAL(19,4);
	_Cost			DECIMAL(19,4);
	_CostSubTotal		DECIMAL(19,4);

	_ItemType		VARCHAR(5);
	_isStock		BOOLEAN;
	_BoMID			bom.bomid%TYPE;
	_Qty_Unit1		DECIMAL(15,4);
	_CashID			VARCHAR(15);
	_CashAAmt		DECIMAL(19,4);
	_CashANote		VARCHAR(255);
	_DebtNote		VARCHAR(255);
	_AllowCredit		DECIMAL(19,4);
	_CreditLimit		DECIMAL(19,4);
	_countCredit		DECIMAL(19,4);
	_CreditAmount		DECIMAL(19,4);
	_CrcID			VARCHAR(5);

	_ContBal 		DECIMAL(19,4);
	_RcvNo			VARCHAR;
	_EmpId			VARCHAR;
	_ConsNo			VARCHAR(15);
	_ConsDNo			SMALLINT;
/* SO Stuff ****/
	_Qty1 			DECIMAL(15,4);
	_Qty1Rcv 		DECIMAL(15,4);

/** Bonus **/
	_StockANoBns 		VARCHAR(15);
	_StockANoteBns		VARCHAR(255);
	_StockADNoBns		INT2;
	_ItemIDBns		VARCHAR(20);
	_WhIDBns		VARCHAR(3);
	_PIDBns			VARCHAR(25);
	_QtyBns			DECIMAL(15,4);
	_QtyXBns		DECIMAL(15,4);
	_UnitBns		VARCHAR(5);
	_CostBns		DECIMAL(19,4);
	_ExcRate		DECIMAL(19,4);

	_AccAsset		VARCHAR(10);
	_AccDisc		VARCHAR(10);
	_AccInv			VARCHAR(10);
	_AccCOGS		VARCHAR(10);
	_AccFreight		VARCHAR(10);
	_AccSale		VARCHAR(10);
	_AccAmt			DECIMAL(19,4);
	_AccAmtForex		NUMERIC(19,4);
	_AccAR			VARCHAR;

	_AccUBDeliSvc		VARCHAR(10);

	_Freight		DECIMAL(19,4);
	_Others			DECIMAL(19,4);

	_count			INT;
	_count1			INT;
	_count2			INT;
	_count3			INT;
	_count4			INT;
	_count5			INT;

	_JnlNo1			VARCHAR(15);
	_JnlNo2			VARCHAR(15);
	_JnlNo3			VARCHAR(15);
	_JnlNo4			VARCHAR(15);
	_JnlNo5			VARCHAR(15);
	_JnlNote		VARCHAR;
	_UBDeliAmt		DECIMAL(19,4);
	_UBDeliAmtForex		DECIMAL(19,4);

	_PerID			VARCHAR(5);
	_BranchID		VARCHAR(10);
	_DeptID			VARCHAR(5);
	_PrjID			VARCHAR(5);
	_Round			INT;
	_DeliItemCount		INT;
	cDeliSale		REFCURSOR;
	cSaleD 			REFCURSOR;
	cSaleD_Service 		REFCURSOR;
	cSO			REFCURSOR;
	cSaleBns		REFCURSOR;
	cSaleAcc		REFCURSOR;
	cSaleCons		REFCURSOR;
	cSaleCRcv		REFCURSOR;
	cCons			REFCURSOR;
	cSaleD1			REFCURSOR;
	cTax			REFCURSOR;
	cSC				REFCURSOR;
	cData			REFCURSOR;

/** POS/SaleCRcv stuff ***/
	_RcvType		VARCHAR;
	_EDCID			VARCHAR;
	_CashAmt		VARCHAR;
	_ChangeAmt		VARCHAR;
	_RcvAmt			VARCHAR;

	_CardNo			VARCHAR;
	_TRefNo			VARCHAR;


	_countCons		INT;
	_countDeli		INT;
	_countNormal		INT;
	_countBonus		INT;
	_countBPTYPE		INT;

	_isDraft		BOOLEAN;
	_JnlType		VARCHAR;
	_LockDate		DATE;
	_SODNo			sod.sodno%TYPE;

	_SumD			NUMERIC(19,4);
	_SumKDeli		NUMERIC(19,4);
	_SumK			NUMERIC(19,4);

	_ItemIDCheck		VARCHAR;

	_countPID		INT2;
	_SaleDTaxAmt	NUMERIC(19,4);
	_SaleDSCAmt		NUMERIC(19,4);
	_AccSaleTax		VARCHAR;
	_AccSC			VARCHAR;
	_TotalTax		NUMERIC(19,4);
	_TotalSC		NUMERIC(19,4);
	_FisRate		NUMERIC(19,4);
	_SaleDTaxAmtForex	NUMERIC(19,4);
	_UBDeliSvcAmt		NUMERIC(19,4);
	_UBDeliSvcAmtForex	NUMERIC(19,4);
	_countSO		INT;
	_CntDeli		INT;
	_CrcIDRcvD		VARCHAR;
	_ExcRateRcvD		NUMERIC(19,4);
	_FisRateRcvD		NUMERIC(19,4);

	_ItemsCost		NUMERIC(19,4);
	_SaleTotalMonth		NUMERIC(19,4);
	_tmp_va1		VARCHAR(1);
	_Qty1_Ordered		NUMERIC(15,4);

	_BTotal			NUMERIC(19,4); -- base currency total
	_BSubtotal		NUMERIC(19,4); -- base currency subtotal
	_MBFTaxAmt		NUMERIC(19,4); -- base currency taxamt
	_MBDiscAmt		NUMERIC(19,4); -- base currency discamt
	
	_TaxableAmt		NUMERIC(19,4);
	_TotalTaxAmt		NUMERIC(19,4);
	_BTotalTaxAmt		NUMERIC(19,4);
	_TotalDiscAmt		NUMERIC(19,4);
	_TotalDisc2Amt		NUMERIC(19,4);
	_DSubtotal		NUMERIC(19,4);
	_DBSubtotal		NUMERIC(19,4);

	_AccRateLR		VARCHAR; -- akun laba/rugi selisih kurs
	_RateLR			NUMERIC(19,4); -- nilai laba/rugi selisih kurs

	_CashCrcID		VARCHAR;
	_SaleBnsNo		SMALLINT;
	_AccBns			VARCHAR(10);
	_InOut			CHAR(1);
	_AccFOC			VARCHAR;

	_HostId			host.hostid%TYPE;
	_HostDesc		host.hostdesc%TYPE;
	_HostStatusCode		host.hoststatuscode%TYPE;
	_SRepId			sale.srepid%TYPE;
	_BillType		bill.billtype%TYPE;

	_CountBillSale		INT;
	_var			VARCHAR;
BEGIN	

	_DeptID:=NULL;
	_PrjID:=NULL;
	_InOut:='I';
/**	_retval:=(0, 'OK');
	RETURN NEXT _retval;
	RETURN;
*/
	SELECT INTO 
		_isDraft, _PerID, _BranchID, _CustID, _SaleType, _SaleDate, _SONo, _TermType, _Term, _PoSID, _PoSSesNo, _CashID, 
		_BSubtotal, _SubTotal, _BTotal, _Total, _PaidAmt, _CrtBy, _CrtDate, _UpdBy, _UpdDate, _EmpId, _ConsNo, _CrcID, 
		_AccFreight, _Freight, _AccDisc, _MBFTaxAmt, _MTaxAmt, _MSCAmt, _ExcRate,_Others,_AccAR, _FisRate, _isTaxed, 
		_isTaxInc, _MBDiscAmt, _MDiscAmt, _SRepId 

		isDraft, PerID, BranchID, CustID, SaleType, SaleDate, SONo, TermType, DueDays, PoSID, PoSSesNo, CashID, 
		basesubtotal, SubTotal, basetotal, Total, PaidAmt, CrtBy, CrtDate, UpdBy, UpdDate, EmpID, ConsNo, CrcID, 
		AccFreight, Freight, AccSDisc, basftaxamt, TaxAmt, SCAmt, ExcRate, others, AccAR, FisRate, isTaxed, 
		TaxInc, basediscamt, discamt, srepid 
	FROM Sale WHERE SaleNo=_SaleNo;

	IF NOT FOUND THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg='Penjualan '|| _SaleNo||' tidak ditemukan';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	SELECT INTO _var SUM('Kode Item:'||d.itemid||' Keterangan: '||d.itemdesc)
	FROM saled d
	JOIN item i ON d.itemid=i.itemid
	WHERE ((d.unit!=i.unit1) AND 
	(i.unit2 is null OR d.unit = i.unit2) AND 
	(i.unit3 is null OR d.unit = i.unit3)) AND d.saleno = _SaleNo;
	IF FOUND THEN
    		RAISE EXCEPTION 'Unit tidak sama! Silahkan cek %', _var;
	END IF;

	/**************** SALE LIMIT *************/
	/*SELECT INTO _SaleTotalMonth * FROM fSaleTotalMonth(_SaleDate);

	IF (_SaleTotalMonth+_Total)>100000000 THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg='Total penjualan anda bulan ini '|| to_char(round(_SaleTotalMonth,2),'999G999G999D99') ||' . Batas maksimal penjualan per bulan adalah 100 juta !!';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;*/
	/******************************************/

/******************************************************************************************************
	CHECK LOCK, DRAFT, VALIDASI
******************************************************************************************************/

	IF (_isDraft IS NOT NULL AND _isDraft=TRUE) THEN
		_retval:=(0, 'OK');
		RETURN NEXT _retval;
		RETURN;
	END IF;

	/** PResto Checking */
	IF EXISTS (SELECT 1 FROM billsale bs JOIN bill b ON bs.billno=b.billno WHERE bs.billno=_BillNo AND bs.saleno=_SaleNo AND b.billtype!='DI') THEN
		_retval.ErrNo:=50555;
		_retval.ErrMsg:=E'Sudah ada Cetak Bill untuk '||_HostDesc||' (spSale_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	SELECT INTO _CountBillSale COUNT(*) FROM billsale WHERE billno=_BillNo AND saleno!=_SaleNo;
	_CountBillSale:=COALESCE(_CountBillSale, 0);

	SELECT INTO _HostStatusCode, _HostId, _HostDesc h.hoststatuscode, h.hostid, h.hostdesc
	FROM host h 
	JOIN bill b ON b.hostid=h.hostid
	WHERE b.billtype='DI' AND b.billno=_BillNo AND b.leavetime IS NULL;
	IF (_CountBillSale=0 AND FOUND) THEN
		IF ('ORDER'!=_HostStatusCode) THEN
			_retval.ErrNo:=50555;
			_retval.ErrMsg:=E'Status meja sudah berubah\nSilahkan refresh terlebih dahulu (spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	END IF;

	_Round:=COALESCE(fReg('ROUND'), '0');

	SELECT INTO _LockDate lockdate FROM TLock WHERE TransType='SALE';
	IF(_LockDate IS NOT NULL AND _LockDate>_SaleDate) THEN
		_retval.ErrNo:=50002;
		_retval.ErrMsg='Penjualan Melebihi Batas Tanggal Kunci Transaksi '|| CAST(_LockDate AS VARCHAR) || '!!';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	-------- count details FROM imported --------------
	SELECT INTO _countNormal COUNT(*) FROM SaleD WHERE SaleNo=_SaleNo AND (DeliNo IS NULL OR DeliNo='') AND (ConsNo IS NULL OR ConsNo='');
	SELECT INTO _countDeli COUNT(*) FROM SaleD WHERE SaleNo=_SaleNo AND DeliNo IS NOT NULL AND DeliNo<>'';
	SELECT INTO _countCons COUNT(*) FROM SaleD WHERE SaleNo=_SaleNo AND ConsNo IS NOT NULL AND ConsNo<>'';
	SELECT INTO _countBonus COUNT(*) FROM SaleBns WHERE SaleNo=_SaleNo;
	SELECT INTO _countBPTYPE COUNT(*) FROM bpbptype WHERE bpid=_CustID AND bptype='CUST';

	--------- cek apakah punya bptype customer (untuk jaga2 ketika import piutang lwt excel) ------------
	IF _countBPTYPE=0 THEN			
		_retval.ErrNo:=50003;
		_retval.ErrMsg='BPID: '||_CustID||' tidak terdaftar sebagai customer (spSale_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;				
	END IF;

	--------- cek & fix POS params ------------
	IF (_PoSSesNo IS NOT NULL) THEN	
		IF NOT EXISTS(SELECT 1 FROM PoSSes WHERE PoSID=_PoSID AND StartTime IS NOT NULL AND EndTime IS NULL) THEN
			_retval.ErrNo:=50003;
			_retval.ErrMsg='Kasir: '||COALESCE(_PoSID,'<kosong>')||' tidak aktif (spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;				
		END IF;
	END IF;

	---------------- cek CashID terisi utk Tunai -------------
	IF (_TermType='C') THEN
		IF((_PoSSesNo IS NOT NULL) AND (_CashID IS NULL)) THEN
			SELECT INTO _CashID CashID FROM PoS WHERE PoSID=_PoSID;

			UPDATE Sale SET CashID=_CashID WHERE SaleNo=_SaleNo;
		END IF;

		IF((_CashID IS NULL) OR (_CashID='')) THEN
			_retval.ErrNo:=50004;
			_retval.ErrMsg:='Error, Kas untuk Penjualan Tunai belum diset (spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;								
		END IF;

		SELECT INTO _CashCrcID crcid FROM cash WHERE cashid=_CashID;
		IF NOT FOUND THEN
			_retval.ErrNo:=50555;
			_retval.ErrMsg:='Mata uang kas#'||_CashID||' belum diset (spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		IF (_CrcID!=_CashCrcID) THEN
			_retval.ErrNo:=50555;
			_retval.ErrMsg:='Mata uang kas#'||_CashID||' tidak sama dengan mata uang penjualan (spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;		
		END IF;

	--------------- Cek kredit limit -----------------
	ELSIF (_TermType='R') THEN
		SELECT INTO _AllowCredit, _CreditLimit, _CreditAmount arlimitfreq, arlimitamt, arbalance FROM BPacc WHERE BPID=_CustID AND CrcID=_CrcID;
		SELECT INTO _countCredit count(*) FROM sale WHERE PayStatus<>'F' and custID=_CustID AND CrcID=_CrcID;
		IF (_AllowCredit=0) THEN
			_retval.ErrNo:=50005;
			_retval.ErrMsg:='Pelanggan '||COALESCE(_CustID,'<kosong>')||' tidak diperkenankan KREDIT. Daftarkan pelanggan baru, ulangi penjualan KREDIT (spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;								
		ELSEIF (_AllowCredit<>-1 AND _AllowCredit<_countCredit) THEN
			_retval.ErrNo:=50006;
			_retval.ErrMsg:='Pelanggan '||COALESCE(_CustID,'<kosong>')||' melebihi jumlah diperkenankan KREDIT. Daftarkan pelanggan baru, ulangi penjualan KREDIT (spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;								
		END IF;

		-- Sebaiknya sudah di-Check di Applikasi agar bisa diconfirmasi ke user
		IF (_CreditLimit=0) THEN
			_retval.ErrNo:=50007;
			_retval.ErrMsg:='Pelanggan '||COALESCE(_CustID,'<kosong>')||' tidak diperkenankan KREDIT. Daftarkan pelanggan baru, ulangi penjualan KREDIT (spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;								
		ELSEIF (_CreditLimit<>-1 AND _CreditLimit<(_CreditAmount+_Total) ) THEN
			_retval.ErrNo:=50008;
			_retval.ErrMsg:='Penjualan melebihi Limit Hutang (spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;								
		END IF;
	END IF;

-------------- Check apakah item diset untuk dijual (isSale?) --------------
	OPEN cSaleD1 FOR
		SELECT saled.itemid FROM saleD JOIN item on saled.itemid=item.itemid WHERE issale=FALSE and saleno=_SaleNo;
		LOOP
			FETCH cSaleD1 INTO _ItemIDCheck;
			EXIT WHEN NOT FOUND;

			-- Kecuali : Item Begbal('0') boleh , kalau tipe nya beginning balance!
			IF NOT(_ItemIDCheck='0' AND _SaleType='B') THEN
				_retval.ErrNo:=50055;
				_retval.ErrMsg:='Error, ItemID:' || _ItemIDCheck || ' tidak di Set untuk Penjualan!! (spSale_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END LOOP;
	CLOSE cSaleD1;


	----------- Deli? check Customer sinkron dgn Salenya --------------
	IF (_countDeli>0) THEN
		OPEN cDeliSale FOR
			SELECT DISTINCT DeliNo FROM SaleD WHERE SaleNo=_SaleNo AND DeliNo IS NOT NULL AND DeliNo<>'';
		LOOP
			FETCH cDeliSale INTO _DeliNo;
			EXIT WHEN NOT FOUND;

			SELECT INTO _CustID2 CustID FROM Deli WHERE DeliNo=_DeliNo;
			IF (_CustID<>_CustID2) THEN
				_retval.ErrNo:=50019;
				_retval.ErrMsg:='Customer Delivery '|| _DeliNo ||' dan Penjualan tidak sama (spSale_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			UPDATE Deli SET IsInvoiced=true WHERE delino=_DeliNo;		
		END LOOP;
		CLOSE cDeliSale;
	END IF;

	
	_StockADNo:=0;
	_count:=0;

/******************************************************************************************************
	Proses Stock / Generate StockA 			

kenapa kok gak di kasih blok IF (countdeli=0)-> karena dimungkinkan di Sale campur 
antara import dari Deli sama input sendiri

******************************************************************************************************/


/**
	Proses Item biasa:GOOD atau Paket:PACK
	BUKAN dari delivery atau Konsinyasi
		karena kalau import dari kedua transaksi diatas stocknya sudah di proses
	
**/

	OPEN cSaleD FOR
		SELECT 
			d.SaleDNo, d.ItemID, d.WhID, d.PID, d.Qty, d.Unit, d.QtyX, i.ItemType, i.isStock,
			d.DeptID, d.PrjID
		FROM SaleD d JOIN Item i ON d.ItemID=i.ItemID
		WHERE d.SaleNo=_SaleNo 
			AND (i.isStock=TRUE OR i.ItemType='PACK')
			AND (d.DeliNo IS NULL OR d.DeliNo='') 
			AND (d.ConsNo IS NULL OR d.ConsNo='');
	LOOP
		FETCH cSaleD INTO _SaleDNo, _ItemID, _WhID, _PID, _Qty, _Unit, _QtyX, _ItemType, _isStock, _DeptID, _PrjID;
		EXIT WHEN NOT FOUND;

		----- Row-1 ? Generate header dulu 
		IF(_count=0) THEN	
			_ItemsCost:=0;

			_StockANo:=fTransNoGet('STOCKA');
			_StockANote:='Penjualan #'|| _SaleNo;
			IF (_StockANo IS NULL) THEN
				_retval.ErrNo:=50009;
				_retval.ErrMsg:='Error getting StockANo (spSale_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			SELECT INTO _spret * FROM spStockA_New(
				_StockANo, _CustID, 'SALE', _SaleDate, 'O', 'SALE', _SaleNo, _StockANote, 
				TRUE, _CrtBy, _CrtDate, _UpdBy, _UpdDate,
				_PerID, _BranchID, _DeptID, _PrjID
			); 

			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

		END IF;
	
		--- Calculate Cost(HPP)
		_StockANote:='Penjualan #'||_SaleNo;

		-- Hitung HPP secara Bulk utk sejumlah Qty biar lebih presisi motong stocknya
		_CostSubTotal:=fUnitCost(_ItemID, _WhID, _PID, _Qty, _Unit);

		IF (_Qty IS NOT NULL) THEN
			_Cost:=_CostSubTotal/_Qty;
		ELSE
			_Cost:=0;
		END IF;

		IF (_Cost IS NULL) THEN
			_retval.ErrNo:='50003';
			_retval.ErrMsg:='Error menghitung HPP! Item:'||COALESCE(_ItemID,'<kosong>')||', Wh:'||COALESCE(_WhID,'<kosong>')||', PID:'||COALESCE(_PID, '<kosong>')||', Unit:'||COALESCE(_Unit, '<kosong>')||' (fUnitCost)(spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;


		IF (_PID IS NULL) THEN
			_PID:='';	
		END IF;

		---------------- PACK: Generate Stock-Details --------------------------
		--------- Item Normal ------------salebnsno

		IF (_ItemType<>'PACK' AND _ItemType<>'SERV' AND _isStock=TRUE) THEN		
			_StockADNo:=_StockADNo+1;
						
			SELECT INTO _spret * FROM spStockAD_New(
					_SaleDate, 'SALE', _StockANo, _StockADNo, 
					_WhID, _ItemID, _PID, _Qty*-1, _Unit, 
					_QtyX*-1, _Cost, _DeptID, _PrjID, true, _SaleNo, _CostSubTotal*-1);

			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;			
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

		ELSIF (_ItemType='PACK') THEN
			SELECT INTO _BoMID bomid FROM bom WHERE itemid=_ItemID AND active=TRUE;
			/**_StockADNo:=_StockADNo+1; dicomment karena sudah ada modifikasi di spstockad_new_bom*/

			IF(_BomID IS NULL) THEN
				_retval.ErrNo:='50014';
				_retval.ErrMsg='Error tidak dapat menemukan B.o.M. untuk Item:'||_ItemID||'(spSale_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			SELECT INTO _spret * FROM spStockAD_New_BoM(
				_SaleDate, _StockAType, _StockANo, _StockADNo, _WhID, _ItemID, _PID, 
				_Qty*-1, _Unit, _QtyX*-1, _Cost, _DeptID, _PrjID, _CrcID
			);

			_StockADNo:=_spret.ErrNo;
			
			IF _spret.ErrNo<>0 AND _spret.ErrMsg<>'OK' THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;			
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
				
		END IF;

		--- Read Qty conversion
		_Conv:=fItemUnit_Conv(_ItemID, _Unit);

		IF (_Conv IS NULL) THEN
			_retval.ErrNo:='50055';
			_retval.ErrMsg:='Error, Konversi ItemID:'||COALESCE(_ItemID, '<kosong>')||', Unit:'||COALESCE(_Unit, '<kosong>')||'!  (fItemUnit_Conv)(spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		--- Update Cost & QtyConversion
		UPDATE SaleD SET 
			Cost=_Cost, 
			Conv=_Conv 
		WHERE SaleNo=_SaleNo AND SaleDNo=_SaleDNo;

		_ItemsCost:=_ItemsCost+_CostSubTotal;
		_count:=_count+1;
	END LOOP;
	CLOSE cSaleD;

/******************************************************************************************************
							PROSES NON STOCK (Jasa)
******************************************************************************************************/
	OPEN cSaleD_Service FOR
		SELECT 
			d.SaleDNo, d.ItemID, d.WhID, d.PID, d.Qty, d.Unit, d.QtyX, 
			BasePrice, ListPrice, d.DiscExp, d.DiscAmt, d.TaxID, d.TaxAmt, i.ItemType
		FROM SaleD d JOIN Item i ON d.ItemID=i.ItemID
		WHERE 
			d.SaleNo=_SaleNo 
			AND (
				(i.ItemType='SERV') 
				OR (i.isStock=false AND i.IsAsm=false) 
				OR (_ConsNo IS NOT NULL)
			);
	LOOP
		FETCH cSaleD_Service INTO _SaleDNo, _ItemID, _WhID, _PID, _Qty, _Unit, _QtyX, _BasePrice, _ListPrice, _DiscExp, _DiscAmt, _TaxID, _TaxAmt, _ItemType;
		EXIT WHEN NOT FOUND;

		--- Read Qty conversion
		_Conv:=fItemUnit_Conv(_ItemID, _Unit);

		--- CDIS (Claimed-Discount) -> Cost=Price(Base-Disc)
		IF (_ItemType='CDIS') THEN
			_Cost=_BasePrice-_DiscAmt;
		ELSE
			_Cost:=fUnitCost(_ItemID, _WhID, _PID, _Unit);
		END IF;

		IF (_Cost IS NULL) THEN
			_retval.ErrNo:='50003';
			_retval.ErrMsg:='Error menghitung HPP! Item:'||COALESCE(_ItemID,'<kosong>')||', Wh:'||COALESCE(_WhID,'<kosong>')||', BATCH:'||COALESCE(_PID,'<kosong>')||', Unit:'||COALESCE(_Unit,'<kosong>')||' (fUnitCost)(spSale_New)';
		END IF;

		UPDATE SaleD SET 
			Cost=_Cost,
			Conv=_Conv
		WHERE SaleNo=_SaleNo AND SaleDNo=_SaleDNo;


	END LOOP;
	CLOSE cSaleD_Service;

/******************************************************************************************************
							PROSES BONUS
******************************************************************************************************/

	OPEN cSaleD FOR
		SELECT 
			d.SaleBnsNo, d.ItemID, d.WhID, d.PID, d.Qty, d.Unit, d.QtyX, i.ItemType, i.isStock, NULL, NULL
		FROM SaleBns d JOIN Item i ON d.ItemID=i.ItemID
		WHERE d.SaleNo=_SaleNo 
			AND (i.isStock=TRUE OR i.ItemType='PACK');
	LOOP
		FETCH cSaleD INTO _SaleDNo, _ItemID, _WhID, _PID, _Qty, _Unit, _QtyX, _ItemType, _isStock, _DeptID, _PrjID;
		EXIT WHEN NOT FOUND;

		----- Row-1 ? Generate header dulu 
		IF(_count=0) THEN	
			_ItemsCost:=0;

			_StockANo:=fTransNoGet('STOCKA');
			_StockANote:='Bonus Penjualan #'|| _SaleNo;
			IF (_StockANo IS NULL) THEN
				_retval.ErrNo:=50009;
				_retval.ErrMsg:='Error getting StockANoBns (spSale_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			SELECT INTO _spret * FROM spStockA_New(
				_StockANo, _CustID, 'SALE', _SaleDate, 'O', 'SALE', _SaleNo, _StockANote, 
				TRUE, _CrtBy, _CrtDate, _UpdBy, _UpdDate,
				_PerID, _BranchID, _DeptID, _PrjID
			); 

			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

		END IF;
	
		--- Calculate Cost(HPP)
		_StockANote:='Bonus Penjualan #'||_SaleNo;

		-- Hitung HPP secara Bulk utk sejumlah Qty biar lebih presisi motong stocknya
		_CostSubTotal:=fUnitCost(_ItemID, _WhID, _PID, _Qty, _Unit);


		IF (_Qty IS NOT NULL) THEN
			_Cost:=_CostSubTotal/_Qty;
		ELSE
			_Cost:=0;
		END IF;

		IF (_Cost IS NULL) THEN
			_retval.ErrNo:='50003';
			_retval.ErrMsg:='Error menghitung HPP! Item:'||COALESCE(_ItemID,'<kosong>')||', Wh:'||COALESCE(_WhID,'<kosong>')||', PID:'||COALESCE(_PID, '<kosong>')||', Unit:'||COALESCE(_Unit, '<kosong>')||' (fUnitCost)(spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;


		IF (_PID IS NULL) THEN
			_PID:='';	
		END IF;

		---------------- PACK: Generate Stock-Details --------------------------
		--------- Item Normal ------------salebnsno

		IF (_ItemType<>'PACK' AND _ItemType<>'SERV' AND _isStock=TRUE) THEN		
			_StockADNo:=_StockADNo+1;
						
			SELECT INTO _spret * FROM spStockAD_New(
					_SaleDate, 'SALE', _StockANo, _StockADNo, 
					_WhID, _ItemID, _PID, _Qty*-1, _Unit, 
					_QtyX*-1, _Cost, _DeptID, _PrjID, true, _SaleNo, _CostSubTotal*-1);

			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;			
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

		ELSIF (_ItemType='PACK') THEN
			SELECT INTO _BoMID bomid FROM bom WHERE itemid=_ItemID AND active=TRUE;
			/**_StockADNo:=_StockADNo+1; dicomment karena sudah ada modifikasi di spstockad_new_bom*/

			IF(_BomID IS NULL) THEN
				_retval.ErrNo:='50014';
				_retval.ErrMsg='Error tidak dapat menemukan B.o.M. untuk Item:'||_ItemID||'(spSale_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			SELECT INTO _spret * FROM spStockAD_New_BoM(
				_SaleDate, _StockAType, _StockANo, _StockADNo, _WhID, _ItemID, _PID, 
				_Qty*-1, _Unit, _QtyX*-1, _Cost, _DeptID, _PrjID
			);

			_StockADNo:=_spret.ErrNo;
			
			IF _spret.ErrNo<>0 AND _spret.ErrMsg<>'OK' THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;			
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
				
		END IF;

		--- Read Qty conversion
		_Conv:=fItemUnit_Conv(_ItemID, _Unit);

		IF (_Conv IS NULL) THEN
			_retval.ErrNo:='50055';
			_retval.ErrMsg:='Error, Konversi ItemID:'||COALESCE(_ItemID, '<kosong>')||', Unit:'||COALESCE(_Unit, '<kosong>')||'!  (fItemUnit_Conv)(spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		--- Update Cost & QtyConversion
		UPDATE SaleBns SET 
			Cost=_Cost, 
			Conv=_Conv 
		WHERE SaleNo=_SaleNo AND SaleBnsNo=_SaleDNo;

		_ItemsCost:=_ItemsCost+_CostSubTotal;
		_count:=_count+1;
	END LOOP;
	CLOSE cSaleD;
	
	SELECT INTO _RcvType r.RcvType FROM SaleRcvDType s, RcvDType r WHERE s.RcvDTypeID=r.RcvDTypeID AND s.SaleNo=_SaleNo;
	IF (_CountBillSale>0 AND _RcvType IS NULL) THEN
		_retval.ErrNo:='50055';
		_retval.ErrMsg:='Error, Tipe Pembayaran belum di isi! (spSale_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;
	
	/** INSERT ke BILLSALE */
	IF (_BillNo IS NOT NULL) THEN
		
		INSERT INTO billsale (billno, saleno, isdefault) VALUES (_BillNo, _SaleNo, (CASE WHEN _CountBillSale=0 THEN TRUE ELSE FALSE END));
		
	END IF;
	
/******************************************************************************************************
		PROSES PAYMENT DAN PIUTANG: 
			- Payment : Cash/Bank
			- CREDIT : Piutang
******************************************************************************************************/
	--- Tunai ? Proses Uang masuk 
	IF (_TermType='C') THEN
		_CashAmt:=_PaidAmt;
		_CashANote:='Penjualan '||COALESCE(fBPName(_CustID),'Cust : <kosong>')||':'||_SaleNo;


/*********************************************************************************************** dulu pake table Sale-Cash-Receive *************
																						OPEN cSaleCRcv FOR
																							SELECT RcvType, EDCID, CashAmt, ChangeAmt, RcvAmt, CardNo, TRefNo
																							FROM SaleCRcv 
																							WHERE SaleNo=_SaleNo;
																						LOOP
																							FETCH cSaleCRcv INTO _RcvType, _CashID, _EDCID, _CashAmt, _ChangeAmt, _RcvAmt, _CardNo, _TRefNo;
																							EXIT WHEN NOT FOUND;			

																							_CashANote='Penjualan-Tunai #'||_SaleNo;
																							IF (_RcvType='CASH') THEN
																								IF (_CashID IS NULL) THEN
																									IF (_POSSesNo IS NOT NULL) THEN
																										SELECT INTO _CashID CashID FROM PoS WHERE PoSID=_PoSID;
																									ELSE
																										_retval.ErrNo:=10001;
																										_retval.ErrMsg:='CashID IS NULL';
																										RAISE EXCEPTION '%', _retval.ErrMsg;
																									END IF;
																								END IF;

																							ELSIF (_RcvType='CASH') THEN
																								SELECT INTO _CashID CashID FROM EDC WHERE EDCID=_EDCID;

																								_CashANote='Penjualan #'||_SaleNo||', Card:'||_CardNo;
																							END IF;

																							_CashAAmt=_RcvAmt;
			
																							SELECT INTO _spret * FROM spCashA_New(
																									_CashID, _CustID, 'SALE', _SaleDate, 'I', 'SALE', _SaleNo, 
																								 _CashAAmt, _CashANote, true, _CrtBy, _CrtDate, _UpdBy, _UpdDate,
																									_PerID, _BranchID, _DeptID, _PrjID
																							);

																							IF _spret.ErrNo<>0 THEN
																								_retval.ErrNo:=_spret.ErrNo;
																								_retval.ErrMsg:=_spret.ErrMsg;
																								RAISE EXCEPTION '%', _retval.ErrMsg;
																							END IF;

																						END LOOP;
																						CLOSE cSaleCRcv;
************************************************************************************************************************/

		-------- set dulu biar mau di generate penerimaan --------
		_tmp_va1:='N';
		UPDATE Sale SET PayStatus=_tmp_va1, PaidAmt=0 WHERE SaleNo=_SaleNo;
		
		SELECT INTO _RcvNo * FROM fTransNoGet('RCV');
		IF (_RcvNo IS NULL) THEN
			_retval.ErrNo:=50041;
			_retval.ErrMsg:='Error getting RcvNo (spRcv_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		INSERT INTO rcv(rcvno,rcvtype,rcvdate,bpid,empid,totspaid,totrcvdisc,totrcvamt,reftype,refno,crtby,crtdate,updby,upddate,isautogen,crcid,excrate,fisrate,branchid) 			
			VALUES(_RcvNo,'SALE', _SaleDate, _Custid, _EmpId, _Total, 0, _Total, 'SALE', _SaleNo, _CrtBy, _CrtDate, _UpdBy, _UpdDate,true, _CrcID, _ExcRate, _FisRate, _BranchID);

		INSERT INTO rcvd(rcvno,rcvdno, rcvdmtd, cashid,rcvdcash,rcvdamt,refno,crcid,excrate,fisrate) 
		VALUES(_RcvNo, 1, 'CASH', _CashId, _Total, _Total, _SaleNo,_CrcID, _ExcRate, _FisRate);

		INSERT INTO spaid(rcvno,spaidno, reftype, refno,spaiddiscamt,spaidamt,crcid,excrate,fisrate) 
		VALUES(_RcvNo, 1, 'SALE', _SaleNo, 0, _Total, _CrcID,_ExcRate,_FisRate);

		SELECT INTO _spret * FROM spRcv_New(_RcvNo);

		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;			
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	
		_tmp_va1:='F';
		UPDATE Sale SET PaidAmt=_Total, PayStatus=_tmp_va1 WHERE SaleNo=_SaleNo;

	---------- CREDIT ? Proses Piutang -------------
	ELSIF (_TermType='R') THEN
		
		IF _RcvType='FOC' THEN
			-------- set dulu biar mau di generate penerimaan --------
			_tmp_va1:='N';
			UPDATE Sale SET PayStatus=_tmp_va1, PaidAmt=0 WHERE SaleNo=_SaleNo;
			
			SELECT INTO _RcvNo * FROM fTransNoGet('RCV');
			IF (_RcvNo IS NULL) THEN
				_retval.ErrNo:=50041;
				_retval.ErrMsg:='Error getting RcvNo (spSale_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			INSERT INTO rcv(rcvno,rcvtype,rcvdate,bpid,empid,totspaid,totrcvdisc,totrcvamt,reftype,refno,crtby,crtdate,updby,upddate,isautogen,crcid,excrate,fisrate,branchid) 			
				VALUES(_RcvNo,'SALE', _SaleDate, _Custid, _EmpId, _Total, 0, _Total, 'SALE', _SaleNo, _CrtBy, _CrtDate, _UpdBy, _UpdDate,true, _CrcID, _ExcRate, _FisRate, _BranchID);
				
			_AccFOC:=fAccDefault('FREEOFCHARGE');
			IF (_AccFOC IS NULL OR _AccFOC='') THEN
				_retval.ErrNo:=50555;
				_retval.ErrMsg:='Akun Free of Charge belum diset.'||E'\n'||'Silahkan disetting pada form Setting Akun';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			INSERT INTO spaid(rcvno,spaidno, reftype, refno,spaiddiscamt,spaidamt,crcid,excrate,fisrate, spaidnote) 
			VALUES(_RcvNo, 1, 'SALE', _SaleNo, 0, _Total, _CrcID,_ExcRate,_FisRate, 'Penjualan '||_SaleNo);
			
			INSERT INTO spaid(rcvno,spaidno, reftype, refno,spaiddiscamt,spaidamt,crcid,excrate,fisrate, spaidnote) 
			VALUES(_RcvNo, 2, 'ACC', _AccFOC, 0, (-1*_Total), _CrcID,_ExcRate,_FisRate, (SELECT accname FROM acc WHERE accno=_AccFOC));

			SELECT INTO _spret * FROM spRcv_New(_RcvNo);

			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;			
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		
			_tmp_va1:='F';
			UPDATE Sale SET PaidAmt=_Total, PayStatus=_tmp_va1 WHERE SaleNo=_SaleNo;
		ELSE
			_DebtNote:='Penjualan '||fBPName(_CustID)||':'||_SaleNo;
			SELECT INTO _spret * FROM spBPA_New(
				_CustID, 'C', _CrcID, _SaleDate, 'SALE', _SaleNo, 
				_Total, _DebtNote, true, _CrtBy, _CrtDate, _UpdBy, _UpdDate,
				_PerID, _BranchID, _DeptID, _PrjID, _ExcRate, _FisRate				
			);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;			
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		
			_tmp_va1:='N';
			UPDATE Sale SET PaidAmt=0, PayStatus=_tmp_va1 WHERE SaleNo=_SaleNo;		
		END IF;
	END IF;

/******************************************************************************************************
		PROSES SO:
			- Update SO:Qty Delivered
			- Check & Update Status SO (close SO)
******************************************************************************************************/
	--- Update SO:Qty-Delivered
	OPEN cSaleD_Service FOR
		SELECT SONo, SODNo, ItemID, PID, fQtyZToQty1(ItemID, Qty, Unit)
		FROM SaleD 
		WHERE 
			SaleNo=_SaleNo 
			AND (SONo IS NOT NULL AND SONo<>'') 
			AND (DELINo IS NULL OR DeliNo='');
	LOOP
		FETCH cSaleD_Service INTO _SONo, _SODNo, _ItemID, _PID, _Qty1;
		EXIT WHEN NOT FOUND;			

		SELECT INTO _Qty1Rcv * FROM spSO_Item_Delivered(_SONo, _ItemID, _PID, _Qty1, _SODNo);
		IF (_Qty1Rcv<_Qty1) THEN
			_retval.ErrNo:=50018;
			_retval.ErrMsg:='Item:'||COALESCE(_ItemID,'<kosong>')||', Qty Delivery > QtySO (spSale_New)';
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	END LOOP;
	CLOSE cSaleD_Service;

	----------- SO, Update status -----------------
	OPEN cSO FOR
		SELECT DISTINCT SONo 
		FROM SaleD 
		WHERE 
			SaleNo=_SaleNo 
			AND (SONo IS NOT NULL AND SONo<>'')
			AND (DELINo IS NULL OR DeliNo='')
			ORDER BY SONo;
	LOOP
		FETCH cSO INTO _SONo;
		EXIT WHEN NOT FOUND;

		SELECT INTO _CustID2 CustID FROM SO WHERE SONo=_SONo;
		IF (_CustID<>_CustID2) THEN
			IF _BillNo IS NOT NULL THEN
				UPDATE SO SET CustID=_CustID WHERE SONo=_SONo;
			ELSE			
				_retval.ErrNo:=50019;
				_retval.ErrMsg:='Customer pada SO '|| _SONo ||' dan pada Penjualan '|| _SaleNo ||' tidak sama (spSale_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END IF;


		SELECT INTO _spret * FROM spSO_ChNUp_Status(_SONo);
		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;			
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
	END LOOP;
	CLOSE cSO;

	/** UPDATE HOST */
	IF (_BillNo IS NOT NULL) THEN
		IF _RcvType='FOC' THEN
			SELECT INTO _spret * FROM spBillStatus_Update(_BillNo, 'SALE', 'FOC');
		ELSE
			IF _RcvType='RCV' THEN
				SELECT INTO _spret * FROM spBillStatus_Update(_BillNo, 'SALE', 'CREDIT');
			ELSE
				SELECT INTO _spret * FROM spBillStatus_Update(_BillNo, 'SALE', 'NEW');
			END IF;
		END IF;
		
		IF (_spret.ErrNo<>0) THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;
		
	END IF;
	
/******************************************************************************************************
		PROSES KONSINYASI
******************************************************************************************************/
	IF (_countCons>0) THEN
		OPEN cSaleD FOR
			SELECT 
				ItemID, fQtyZToQty1(ItemID, Qty, Unit), QtyX, ConsNo, ConsDNo, PID 
			FROM SaleD  
			WHERE 
				SaleNo=_SaleNo AND (ConsNo IS NOT NULL AND ConsNo<>'')
			ORDER BY ConsNo, SaleDNo;

		LOOP
			FETCH cSaleD INTO _ItemID, _Qty, _QtyX, _ConsNo, _ConsDNo, _PID;
			EXIT WHEN NOT FOUND;

			SELECT INTO _Qty1_Ordered SUM(fQtyZToQty1(ItemID, QtySellIn, Unit)-QtySellOut-QtyCret) FROM consd WHERE itemid=_ItemID AND pid=_PID AND consno=_ConsNo;
			IF (_Qty>_Qty1_Ordered) THEN
				_retval.ErrNo:=50555;
				_retval.ErrMsg:='Item:'|| _ItemID ||', Qty Sell Out > Qty Sell In (spSale_New)';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			IF (_PID IS NOT NULL AND _PID!='') THEN
				SELECT INTO _countPID COUNT(pid) FROM saled WHERE saleno=_SaleNo AND pid=_PID;
				IF (_countPID>1) THEN
					_retval.ErrNo:=50555;
					_retval.ErrMsg:='Duplicate PID#'||_PID||' (spSale_New)';
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			END IF;

			IF (_PID IS NULL) THEN
				UPDATE ConsD SET QtyXSellOut=QtyXSellOut+_QtyX, QtySellOut=QtySellOut+_Qty
				WHERE ConsNo=_ConsNo AND ItemID=_ItemID AND ConsDNo=_ConsDNo;
			ELSE
				UPDATE ConsD SET QtyXSellOut=QtyXSellOut+_QtyX, QtySellOut=QtySellOut+_Qty
				WHERE ConsNo=_ConsNo AND ItemID=_ItemID AND PID=_PID AND ConsDNo=_ConsDNo;			
			END IF;
		END LOOP;	
		CLOSE cSaleD;

		OPEN cSaleCons FOR
			SELECT DISTINCT ConsNo FROM SaleD WHERE SaleNo=_SaleNo AND ConsNo IS NOT NULL AND ConsNo<>'';
		LOOP
			FETCH cSaleCons INTO _ConsNo;
			EXIT WHEN NOT FOUND;

			SELECT INTO _spret * FROM spSetConsStatus(_ConsNo);
			IF _spret.ErrNO<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END LOOP;
		CLOSE cSaleCons;
	END IF;

/**************************************************************************************************
	PROSES ACCOUNTING
**************************************************************************************************/

	IF (isAccInstalled()) THEN
		_JnlNo1:=fTransNoGet('JURNAL');

		IF(_SaleType='B')THEN
			_JnlNote:='Set Saldo Awal Piutang '||fBPName(_CustID)||':'||_SaleNo;
			_JnlType:='BEG';
		ELSE
			_JnlNote:='Penjualan '||fBPName(_CustID)||':'||_SaleNo;
			_JnlType:='SALE';
		END IF;

		------- Generate Jurnal Header untuk JurnalVoucher(JV) Penjualan
		SELECT INTO _spret * FROM spJnl_Insert(
			_JnlNo1, _JnlType, _SaleDate,'SALE', _SAleNo,
			_JnlNote, true, true, CAST(0 AS NUMERIC(19,4)),
			_CrtBy, _CrtDate, _UpdBy, _UpdDate,
			_PerID, _BranchID, _DeptID, _PrjID, _CrcID, _ExcRate, _FisRate				
		);

		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		----- Generate Jurnal-Header untuk Jurnal-Voucher-HPP --------
		IF(_SaleType<>'B') THEN
			_JnlNo2:=fTransNoGet('JURNAL');		
			_JnlNote:= 'HPP '||fBPName(_CustID)||':'||_SaleNo;
			SELECT INTO _spret * FROM spJnl_Insert(
				_JnlNo2, 'SALE', _SaleDate,'SALE', _SAleNo,
				_JnlNote, true, true, CAST(0 AS NUMERIC(19,4)),
				_CrtBy, _CrtDate, _UpdBy, _UpdDate,
				_PerID, _BranchID, _DeptID, _PrjID, _CrcID, _ExcRate, _FisRate				
			);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END IF;

		----- Generate Jurnal-Header untuk Bonus --------
		IF(_countBonus>0) THEN
			_JnlNo5:=fTransNoGet('JURNAL');		
			_JnlNote:= 'Bonus '||fBPName(_CustID)||':'||_SaleNo;
			SELECT INTO _spret * FROM spJnl_Insert(
				_JnlNo5, 'SALE', _SaleDate,'SALE', _SAleNo,
				_JnlNote, true, true, CAST(0 AS NUMERIC(19,4)),
				_CrtBy, _CrtDate, _UpdBy, _UpdDate,
				_PerID, _BranchID, _DeptID, _PrjID, _CrcID, _ExcRate, _FisRate				
			);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END IF;
				
		------- Fetch Akun Asset-Lancar(KasBank/Piutang) --------
		IF(_SaleType<>'B') THEN
			IF _TermType='C' THEN	--- Kas/Bank
				_AccAsset:=fAccCash(_CashID, _InOut);
			ELSE	 --- Piutang			
				_AccAsset:=fBpAcc(_CustID, _CrcID, 'AR');
			END IF;
		ELSE
			--- BegBal: Piutang
			_AccAsset:=_AccAR;
		END IF;


		_count1:=0;
		_count2:=0;
		_count5:=0;

		------- Jurnal Ayat Asset (Cash/Piutang) -------------
		_count1:=_count1+1;	
--RAISE EXCEPTION 'Total %', _Total;	
		SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _count1, _AccAsset, 'D', _BTotal, _DeptID, _PrjID, _Total);
		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		-------- Jurnal Ayat Sales/Income --------------
		OPEN cSaleAcc FOR
			SELECT fItemAcc(ItemID, 'SALE'), DeptID, PrjID, SUM(basesubtotal), SUM(subtotal)
			FROM SaleD 
			WHERE SaleNo=_SaleNo 
			GROUP BY fItemAcc(ItemID, 'SALE'), DeptID, PrjID;
		LOOP
			FETCH cSaleAcc INTO _AccSale, _DeptID, _PrjID, _AccAmt, _AccAmtForex;
			EXIT WHEN NOT FOUND;
		
			_count1:=_count1+1;		
			SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _count1, _AccSale, 'K', _AccAmt, _DeptID, _PrjID, _AccAmtForex);

			
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END LOOP;
		CLOSE cSaleAcc;

		/** ==================== LABA RUGI SELISIH KURS ================================ */
		_RateLR:=(_BTotal+_MBDiscAmt)-(_BSubtotal+_MBFTaxAmt+_MSCAmt);
		IF (_RateLR!=0) THEN
			_count1:=_count1+1;
			_AccRateLR:=fAccDefault('PKKURS');
			IF (_AccRateLR IS NULL OR _AccRateLR='') THEN
				_retval.ErrNo:=50555;
				_retval.ErrMsg:='Akun PK Selisih Kurs belum diset.'||E'\n'||'Silahkan disetting pada form Setting Akun';
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;

			SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _count1, _AccRateLR, 'K', _RateLR, _DeptID, _PrjID, NULL, _RateLR/_ExcRate);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END IF;	

		---- Jurnal Discount Header --------
		IF (_MDiscAmt<>0) THEN
			IF (_AccDisc IS NULL) THEN
				_AccDisc:=fAccDefault('SALEDISC');
			END IF;

			_count1:=_count1+1;		
			SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _count1, _AccDisc, 'K', _MBDiscAmt*-1, NULL, NULL, _MDiscAmt*-1);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END IF;

		--- Ayat Pajak , groupped by item tax per item -----
		_TotalTax:=0;
		OPEN cTax FOR
			SELECT SUM(basftotaltaxamt), SUM(totaltaxamt), AccSaleTax, DeptID, PrjID
			FROM SaleD d JOIN tax ON d.taxid=tax.taxid
			WHERE d.SaleNo=_SaleNo	AND (d.taxid IS NOT NULL)
			GROUP BY tax.AccSaleTax, d.DeptID, d.PrjID;
		LOOP
			FETCH cTax INTO _SaleDTaxAmt, _SaleDTaxAmtForex, _AccSaleTax, _DeptID, _PrjID;
			EXIT WHEN NOT FOUND;

			_count1:=_count1+1;

			IF (_AccSaleTax IS NULL) THEN
				_retval.ErrNo:=504334;
				_retval.ErrMsg:='Akun Pajak Penjualan belum di set, silahkan set di master Pajak (spSale_New)';
				RETURN NEXT _retval;
			END IF;

			SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _count1, _AccSaleTax, 'K', _SaleDTaxAmt, _DeptID, _PrjID, _SaleDTaxAmtForex);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END LOOP;
		CLOSE cTax;
		
		--- Ayat Service Charge , groupped by item sc per item -----
		_TotalSC:=0;
		OPEN cSC FOR
			SELECT SUM(totalscamt), AccSC, DeptID, PrjID
			FROM SaleD d JOIN sc ON d.scid=sc.scid
			WHERE d.SaleNo=_SaleNo	AND (d.scid IS NOT NULL)
			GROUP BY sc.AccSC, d.DeptID, d.PrjID;
		LOOP
			FETCH cSC INTO _SaleDSCAmt, _AccSC, _DeptID, _PrjID;
			EXIT WHEN NOT FOUND;

			_count1:=_count1+1;

			IF (_AccSC IS NULL) THEN
				_retval.ErrNo:=504334;
				_retval.ErrMsg:='Akun Service Charge belum di set, silahkan set di master Service Charge (spSale_New)';
				RETURN NEXT _retval;
			END IF;

			SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _count1, _AccSC, 'K', _SaleDSCAmt, _DeptID, _PrjID, _SaleDTaxAmtForex);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END LOOP;
		CLOSE cSC;


		---- Jurnal Freight --------
		IF (_Freight<>0) THEN
			_count1:=_count1+1;
	
			IF (_AccFreight IS NULL) THEN
				_AccFreight:=fAccDefault('SALEFREIGHT');
			END IF;	

			SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _count1, _AccFreight, 'K', _Freight*_ExcRate, NULL, NULL, _Freight);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END IF;

		---- Jurnal biaya lain2
		IF (_Others<>0) THEN
			_count1:=_count1+1;		
			SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo1, _count1, fAccDefault('PKROUND'), 'K', _Others*_ExcRate, NULL, NULL, _Others);
			IF _spret.ErrNo<>0 THEN
				_retval.ErrNo:=_spret.ErrNo;
				_retval.ErrMsg:=_spret.ErrMsg;
				RAISE EXCEPTION '%', _retval.ErrMsg;
			END IF;
		END IF;


/****************************** Jurnal Voucher HPP Perpetual **************************************/

--------- Posting Jurnal Voucher HPP Penjualan Normal, (BUKAN begbal) ---------------
		IF(_SaleType<>'B') THEN
			-- Ayat Jurnal HPP untuk item stocked, baik yg dari Deli mauapun Normal (langsung penjualan)
			OPEN cSaleAcc FOR
				SELECT fItemAcc(d.itemid, 'COST'), d.deptid, d.prjid, 
				SUM(ROUND(fUnitCost(d.itemid, d.whid, d.pid, d.qty, d.unit), _Round))	--SUM(fUnitCost(d.ItemID, d.WhID, d.PID, d.Qty, d.Unit))
				FROM saled d 
				JOIN item i ON d.itemid=i.itemid
				WHERE saleno=_SaleNo 
				AND (i.isstock=TRUE OR i.itemtype='PACK') 
				AND (d.consno IS NULL OR d.consno='') 
				GROUP BY fItemAcc(d.itemid, 'COST'), d.deptid, d.prjid;
			LOOP
				FETCH cSaleAcc INTO _AccCOGS, _DeptID, _PrjID, _AccAmt;
				EXIT WHEN NOT FOUND;

				IF(_AccCOGS IS NOT NULL) THEN
					_count2:=_count2+1;
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo2, _count2, _AccCOGS, 'D', _AccAmt, _DeptID, _PrjID, _AccAmt/_ExcRate);

					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				END IF;
			END LOOP;
			CLOSE cSaleAcc;

			-------- Ayat Unbilled service (gantinya HPP) untuk yg pake delivery ---------
			IF (_countDeli>0) THEN	

				
				--- Unbilled Service
				_AccUBDeliSvc:=fAccDefault('UBDELISVC');
				SELECT INTO
					_UBDeliSvcAmtForex, _BSubtotal		--??? mestinya baca cost atau price-disc sih ?
					SUM(CAST(ROUND(Qty*(ListPrice-fDiscCalc(DiscExp, ListPrice)), _Round) AS NUMERIC(19,4))), 
					SUM(CAST(ROUND(Qty*_ExcRate*(ListPrice-fDiscCalc(DiscExp, ListPrice)), _Round) AS NUMERIC(19,4)))
				FROM SaleD JOIN Item ON SaleD.ItemID=Item.ItemID
				WHERE 
					SaleNo=_SaleNo 
					AND isStock=FALSE 
					AND (Consno IS NULL OR ConsNo='')
					AND (DeliNo IS NOT NULL AND DeliNo<>'');

				IF (FOUND AND _UBDeliSvcAmtForex IS NOT NULL) THEN
					_UBDeliSvcAmt:=_UBDeliSvcAmtForex*_ExcRate;

					--- ayat UBDELISVC
					_count2:=_count2+1;
					SELECT INTO _spret * 
					FROM spJnlD_Insert(_JnlNo2, _count2, _AccUBDeliSvc, 'D', _BSubtotal, _DeptID, _PrjID, _UBDeliSvcAmt);

					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;

					-- ayat UBDELI nya
					_count2:=_count2+1;
					SELECT INTO _spret * 
					FROM spJnlD_Insert(_JnlNo2, _count2, fAccDefault('UBDELI'), 'K', _BSubtotal, _DeptID, _PrjID, _UBDeliSvcAmt);

					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;

				END IF;		

				--------- Ayat Unbilled Delivered stocked-Items ---------------
				SELECT INTO 
					_UBDeliAmt	--??? mestinya baca cost atau price sih ?
					SUM(CAST(ROUND(Qty*Cost, _Round) AS NUMERIC(19,4)))
				FROM SaleD d
				JOIN Item i ON d.ItemID=i.ItemID
				WHERE 
					Saleno=_SaleNo
					AND i.isStock=TRUE
					AND (d.DeliNo IS NOT NULL AND d.DeliNo<>'')
					AND (d.ConsNo IS NULL OR d.ConsNo='');

				IF (FOUND AND _UBDeliAmt IS NOT NULL) THEN
					_UBDeliAmtForex:=_UBDeliAmt/_ExcRate;	--ExcRate nya ambil di Deli atau di Sale ?


					-- ayat HPP sudah di post diatas

					-- ayat UBDELI, 
					_count2:=_count2+1;
					SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo2, _count2, fAccDefault('UBDELI'), 'K', _UBDeliAmt, _DeptID, _PrjID, _UBDeliAmtForex);
					IF _spret.ErrNo<>0 THEN
						_retval.ErrNo:=_spret.ErrNo;
						_retval.ErrMsg:=_spret.ErrMsg;
						RAISE EXCEPTION '%', _retval.ErrMsg;
					END IF;
				END IF;

				/** Jurnal Item Paket */
				OPEN cData FOR
					SELECT f.accno, f.deptid, f.prjid, SUM(ROUND(f.accamt, _Round)) 
					FROM spJnlPacketInv(_SaleNo, 'SALE', TRUE) f 
					GROUP BY f.accno, f.deptid, f.prjid;
				LOOP
					FETCH cData INTO _AccInv, _DeptID, _PrjID, _AccAmtForex;
					EXIT WHEN NOT FOUND;

					_AccAmt:=_AccAmtForex;
					IF(_AccInv IS NOT NULL) THEN
						_count2:=_count2+1;
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo2, _count2, _AccInv, 'K', _AccAmt, _DeptID, _PrjID, _AccAmtForex*_ExcRate);
						IF _spret.ErrNo<>0 THEN
							_retval.ErrNo:=_spret.ErrNo;
							_retval.ErrMsg:=_spret.ErrMsg;
							RAISE EXCEPTION '%', _retval.ErrMsg;
						END IF;
					END IF;
				END LOOP;
				CLOSE cData;
			END IF;

			-- bukan dari Deli (countNormal>0)
			IF (_countNormal>0) THEN
				-------------- Ayat Inventory ----------------------------
				OPEN cSaleAcc FOR
					SELECT accno, deptid, prjid, SUM(accamt) 
					FROM (
						SELECT fItemAcc(d.ItemID, 'INV') AS accno, SUM(ROUND(fUnitCost(d.itemid, d.whid, d.pid, d.qty, d.unit), _Round)) AS accamt, 
						d.DeptID, d.PrjID 
						FROM SaleD d JOIN Item i ON d.ItemID=i.ItemID
						WHERE d.SaleNo=_SaleNo AND i.isStock=true 
						AND (d.ConsNo IS NULL OR d.ConsNo='') 
						AND (d.DeliNo IS NULL OR d.DeliNo='')
						GROUP BY fItemAcc(d.ItemID, 'INV'), d.DeptID, d.PrjID
						UNION ALL

						SELECT f.accno, ROUND(f.accamt, _Round), f.deptid, f.prjid 
						FROM spJnlPacketInv(_SaleNo) f
					) a 
					GROUP BY accno, deptid, prjid;
				LOOP
					FETCH cSaleAcc INTO _AccInv, _DeptID, _PrjID, _AccAmtForex;
					EXIT WHEN NOT FOUND;

					_AccAmt:=_AccAmtForex; -- stock sudah pasti base currency, jadi sama
					IF(_AccInv IS NOT NULL) THEN
						_count2:=_count2+1;
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo2, _count2, _AccInv, 'K', _AccAmt, _DeptID, _PrjID, _AccAmtForex*_ExcRate);
						IF _spret.ErrNo<>0 THEN
							_retval.ErrNo:=_spret.ErrNo;
							_retval.ErrMsg:=_spret.ErrMsg;
							RAISE EXCEPTION '%', _retval.ErrMsg;
						END IF;

					END IF;

				END LOOP;
				CLOSE cSaleAcc;
			END IF;	--- IF (_countNormal>0)

		

			------Khusus Konsinyasi, jurnal hpp yg laku -----
			IF (_countCons>0) THEN 	---- #7589
				_JnlNo3:=fTransNoGet('JURNAL');
				_JnlNote:='HPP '||fBPName(_CustID)||':'||_SaleNo;

				_count3:=0;
				_count4:=0;
				SELECT INTO _spret * FROM spJnl_Insert(
					_JnlNo3, _JnlType, _SaleDate,'SALE', _SAleNo,
					_JnlNote, true, true, CAST(0 AS NUMERIC(19,4)),
					_CrtBy, _CrtDate, _UpdBy, _UpdDate,
					_PerID, _BranchID, _DeptID, _PrjID, _CrcID, _ExcRate, _FisRate				
				);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;

				OPEN cCons FOR
					SELECT fItemAcc(SaleD.ItemID, 'COST'), SaleD.DeptID, SaleD.PrjID, 
					--SUM(ROUND(Qty*SaleD.Cost, _Round))
					SUM(ROUND(fUnitCost(SaleD.itemid, SaleD.whid, SaleD.pid, SaleD.qty, SaleD.unit), _Round)) AS accamt 
					FROM SaleD LEFT JOIN CONSD ON SaleD.consno=consd.consno AND SaleD.ItemID=consd.ItemID
					WHERE SaleNo=_SaleNo AND SaleD.consno IS NOT NULL
					GROUP BY fItemAcc(SaleD.ItemID, 'COST'), SaleD.DeptID, SaleD.PrjID;
					LOOP
						FETCH cCons INTO _AccCOGS,_DeptID,_PrjID,_AccAmt;
						EXIT WHEN NOT FOUND;

						IF(_AccCOGS IS NOT NULL) THEN
							_count3:=_count3+1;
							SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo3, _count3, _AccCOGS, 'D', _AccAmt, _DeptID, _PrjID,_AccAmt);
							IF _spret.ErrNo<>0 THEN
								_retval.ErrNo:=_spret.ErrNo;
								_retval.ErrMsg:=_spret.ErrMsg;
								RAISE EXCEPTION '%', _retval.ErrMsg;
							END IF;

							_count3:=_count3+1;
							SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo3, _count3, fAccDefault('ARCONS'), 'K', _AccAmt, _DeptID, _PrjID,_AccAmt);
							IF _spret.ErrNo<>0 THEN
								_retval.ErrNo:=_spret.ErrNo;
								_retval.ErrMsg:=_spret.ErrMsg;
								RAISE EXCEPTION '%', _retval.ErrMsg;
							END IF;
						END IF;
					END LOOP;
				CLOSE cCons;

			END IF;	-- #7589 IF (_countCons>0) 


			-- jurnal bonus
			IF (_countBonus>0) THEN	
				-------------- Ayat Inventory ----------------------------
				OPEN cSaleAcc FOR
					SELECT accno, NULL, NULL, SUM(accamt) 
					FROM (
						SELECT fItemAcc(d.ItemID, 'INV') AS accno, SUM(ROUND(d.Qty*d.Cost, _Round)) AS accamt, NULL as deptid, NULL as prjid
						FROM SaleBns d JOIN Item i ON d.ItemID=i.ItemID
						WHERE d.SaleNo=_SaleNo AND i.isStock=true 
						GROUP BY fItemAcc(d.ItemID, 'INV')
						UNION

						SELECT f.accno, f.accamt, f.deptid, f.prjid 
						FROM spJnlPacketInv(_SaleNo, 'BNS') f
					) a 
					GROUP BY accno, deptid, prjid;
				LOOP
					FETCH cSaleAcc INTO _AccInv, _DeptID, _PrjID, _AccAmtForex;
					EXIT WHEN NOT FOUND;

					_AccAmt:=_AccAmtForex; -- stock sudah pasti base currency, jadi sama
					IF(_AccInv IS NOT NULL) THEN
						_count5:=_count5+1;
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo5, _count5, _AccInv, 'K', _AccAmt, _DeptID, _PrjID, _AccAmtForex*_ExcRate);
						IF _spret.ErrNo<>0 THEN
							_retval.ErrNo:=_spret.ErrNo;
							_retval.ErrMsg:=_spret.ErrMsg;
							RAISE EXCEPTION '%', _retval.ErrMsg;
						END IF;

						_AccBns:=fAccDefault('SALEBNS');
						_count5:=_count5+1;
						SELECT INTO _spret * FROM spJnlD_Insert(_JnlNo5, _count5, _AccBns, 'D', _AccAmt, _DeptID, _PrjID, _AccAmtForex*_ExcRate);
						IF _spret.ErrNo<>0 THEN
							_retval.ErrNo:=_spret.ErrNo;
							_retval.ErrMsg:=_spret.ErrMsg;
							RAISE EXCEPTION '%', _retval.ErrMsg;
						END IF;

					END IF;

				END LOOP;
				CLOSE cSaleAcc;
			END IF;	--- IF (_countBonus>0)
		END IF;

		---------- execute voucher-1 (sales) spJnlNew --------------
		SELECT INTO _spret * FROM spJnl_New(_JnlNo1);
		IF _spret.ErrNo<>0 THEN
			_retval.ErrNo:=_spret.ErrNo;
			_retval.ErrMsg:=_spret.ErrMsg;
			RAISE EXCEPTION '%', _retval.ErrMsg;
		END IF;

		----- #54389
		IF(_SaleType<>'B') THEN
			--- posting voucher stock/unbilled
			IF(_count2>0) THEN
				SELECT INTO _spret * FROM spJnl_New(_JnlNo2);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			ELSE
				DELETE FROM jnl WHERE jnlno=_JnlNo2;
			END IF;

			--- posting bonus
			IF(_countBonus>0) THEN
				SELECT INTO _spret * FROM spJnl_New(_JnlNo5);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
			ELSE
				DELETE FROM jnl WHERE jnlno=_JnlNo5;
			END IF;

			IF(_countCons>0) THEN
				SELECT INTO _spret * FROM spJnl_New(_JnlNo3);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
/*				SELECT INTO _spret * FROM spJnl_New(_JnlNo4);
				IF _spret.ErrNo<>0 THEN
					_retval.ErrNo:=_spret.ErrNo;
					_retval.ErrMsg:=_spret.ErrMsg;
					RAISE EXCEPTION '%', _retval.ErrMsg;
				END IF;
*/
			END IF;
		END IF;	-- #54389

	END IF; -- use Accounting


	_retval:=(0, 'OK');
	RETURN NEXT _retval;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION spsale_new(character varying, character varying)
  OWNER TO bits;
